{- 
Prevodjenje:
-- vektorizujemo modul SK ili tako sto zadajemo opciju prilikom prevodjenja ili stavljanjem pragme na pocetku koda 
{-# OPTIONS_GHC -fvectorise #-}
-- bitno je ukljuciti paket prilikom prevodjenja jer je on po difoltu nevidljiv
ghc -fvectorise -package dph-lifted-vseg SK.hs 
-- nevektorizovan main program
ghc -package dph-lifted-vseg 1_main.hs
-- povezivanje objektnih fajlova
ghc -threaded -rtsopts -package dph-lifted-vseg 1_main.o SK.o

-- opcije -threaded i -rtsopts nam dozvoljavaju da eksplicitno odredimo broj cvorova koji ce izvrsavati nas program

-- pokretanje izvrsnog programa sa 4 cvora (u opstem slucaju -NBrojCvorova)
./a.out +RTS -N4
-}

{-
kod sa standardnim ulazom ne moze biti vektorizovan i zbog toga je bilo neophodno dekomponovati program u dva fajla 
SK.hs koji sadrzi vektorizovan deo i interfejs suma_omot
1_main.hs koji sadrzi nevektorizovan deo, ucitava podatke i poziva vektorizovan kod preko interfejsa suma_omot
-}

import Data.Array.Parallel
import Data.Array.Parallel.PArray (PArray, fromList)
 
import SK (suma_omot)  -- importujemo iz modula samo funkciju koja nam sluzi kao interfejs ka vektorizovanom kodu

-- liniju teksta koju smo ucitali sa getLine konvertujemo u listu brojeva
-- funkcija words parsiranjem linije pravi listu reci
-- funkcija read svaku od reci konvertuje u broj, u opstem slucaju konvertuje iz tipa String u neki drugi u zavisnosti sta je zapisano u stringu  
konvertuj x = map (read:: String->Double) (words x)


{-
Funkcije za rad sa standardnim ulazom: getLine (ucitava celu liniju u string), getChar (ucitava jedan karakter), getContents (ucitava celokupan sadrzaj u string).

U nasem primeru vektor se zadaje u liniji koju ucitavamo funkcijom getLine, a nakon toga parsiramo brojeve, elemente vektora za koji racunamo sumu kvadrata
-}
main :: IO ()
-- naredba do daje mogucnost da se funkcija definise kao niz poziva drugih funkcija
main =  do
	v <- getLine
	{-
	iz standardnog oblika liste koristeci funkciju fromList prevodimo listu u prelazni oblik PArray da bismo mogli da pozovemo omot funkciju koja ce onda pozvati vektorizovani deo programa
	-} 
	print (suma_omot (fromList (konvertuj v)))
	
