{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS -fvectorise #-}

module DevK (dev_omot) where
import Data.Array.Parallel
import Data.Array.Parallel.Prelude.Int as I
import qualified Prelude -- zbog mod funkcije

dev_kv :: Int -> Int -> [:Int:]
-- enumFromTo n m kreira listu brojeva u intervalu od n do m
-- funkcijom filter izdvajamo elemente koji su deljivi sa m
-- nakon cega ih transformisemo u svoje kvadrate
dev_kv n m = mapP f2 (filterP f1 [: x | x <- enumFromToP 2 n :] )
	where 
		f1 x = mod x m I.== 0 	
		f2 x = x I.* x		

-- drugi nacin bez koriscenja mapP i filterP
-- dev_kv n m = [: x I.* x | x <- enumFromToP 2 n, mod x m I.== 0 :]

{-# NOINLINE dev_omot #-}
dev_omot :: Int -> Int -> PArray Int
dev_omot n m = toPArrayP (dev_kv n m)
