{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS -fvectorise #-}

module Jedan (jedan_omot) where
import Data.Array.Parallel
import Data.Array.Parallel.Prelude.Int as I

sadrzi :: [:Int:] -> [:Int:]
-- izdvajamo iz liste samo brojeve koji sadrze cifru 1  
sadrzi br = filterP f br
	where 
		-- funkcija kao argument uzima jedan element liste i proverava da li x sadrzi cifru 1 izdvajanjem cifara broja x
		f x 
			| x I.== 0  = False
			| x `I.mod` 10 I.== 1 = True
			| otherwise = f (x `I.div` 10) 	

{-# NOINLINE jedan_omot #-}
jedan_omot :: PArray Int -> PArray Int
jedan_omot br = toPArrayP (sadrzi (fromPArrayP br))
