{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS_GHC -fvectorise #-}
 
module M (mat_omot)
where
 
import Data.Array.Parallel
import Data.Array.Parallel.Prelude
import Data.Array.Parallel.Prelude.Double as D

-- proizvod matrice i vektora svodimo na skalarni proizvod vrsta matrice sa vektorom
mat_pro :: [: [:Double:] :] -> [:Double:] -> [:Double:]
mat_pro m v = [: skalar_pro r v | r <- m :]
-- pomocna funkcija koju koristimo u glavnoj funkciji  
skalar_pro :: [:Double:] -> [:Double:] -> Double
skalar_pro xs ys = sumP [:x D.* y | x <- xs | y <- ys:]

-- da se ne bi povezivala sa nevektorizovanim kodom 
{-# NOINLINE mat_omot #-}
mat_omot :: (PArray (PArray Double)) -> PArray Double -> PArray Double
-- funkcija dobija listu listi brojeva - ugnjezdenu listu koja se prevodi u vektorizovan oblik funkcijom fromNestedPArray
-- rezultat poziva funkcije mat_pro je paralelni niz, potrebno ga je prevesti u prelazni oblik PArray Double funkcijom toPArrayP da bismo iz main funkcije mogli prikazati rezultat na izlaz 
mat_omot v w = toPArrayP (mat_pro (fromNestedPArrayP v) (fromPArrayP w))

