{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS -fvectorise #-}

module Prime (primes_omot)
where
import Data.Array.Parallel
-- ukoliko koristimo funkcije koje postoje pod istim imenom u razlicitim modulima, neophodno je pri pozivu funkcije navesti puno ime kao sto smo videli u prethodnim zadacima, iz prakticnih razloga sa as NovoIme mozemo uvesti skracenicu za neki modul
import Data.Array.Parallel.Prelude.Int as I
import qualified Prelude

primes :: Int -> [:Int:]
primes n 
	| n I.== 1	= emptyP -- pravi praznu par. listu
	| n I.== 2	= singletonP 2 -- pravi jednoclanu par. listu sa zadatim elementom
	-- +:+ je vektorizovana verzija za konkatenaciju listi
	| otherwise	= sps +:+ [: i | i <- enumFromToP (sq I.+ 1) n, notMultiple sps i:]
	where	
		sq = sqrt n -- optimizujemo pretragu do korena iz n
		sps = primes sq
		notMultiple :: [:Int:] -> Int -> Bool
		-- funkcija proverava da li svi elementi liste ps ne dele broj i 
		-- pravimo listu el. tipa Bool koji predstavljaju ispunjenost uslova deljivosti broja i elementom liste ps
		-- konjukcija elemenata ovakve liste daje True ako nijedan el. liste ne deli broj i ili False ukoliko ga bar jedan deli 
		notMultiple ps i = andP [: mod i p I./= 0 | p <- ps:] -- konjukcija iskaza koji su elementi liste

{-# NOINLINE primes_omot #-}
primes_omot :: Int -> PArray Int
primes_omot n = toPArrayP (primes n)
