{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS -fvectorise #-}

module QS (quicksort) where
import Data.Array.Parallel
-- uvodimo skracenice za module jer koristimo predefinisane funkcije iz njih
import Data.Array.Parallel.Prelude.Double        as D
import qualified Data.Array.Parallel.Prelude.Int as I

qsortVect':: [: Double :] -> [: Double :]
-- ukoliko je niz jednoclan ili prazan vec je sortiran
qsortVect' xs | lengthP xs I.<=  1 = xs
              | otherwise =
-- ukoliko je viseclan niz, uzimamo sredisnji element p i na osnovu njega odredjujemo
-- ls - deo niza elemenata manjih od p
-- gs - deo niza elemenata vecih od p
  let p  = xs !: (lengthP xs `I.div` 2)
      ls = [:x | x <- xs, x D.< p:]
      gs = [:x | x <- xs, x D.> p:]
-- na svaki deo niza primenjujemo qsort
      ss = mapP qsortVect' [:ls, gs:]
  in
-- na kraju spajamo sortirane delove,  prvo deo niza sa el. manjim od p, onda sve duplikate od p i na kraju deo sa el. vecim od p 
 (ss !: 0) +:+ [:x | x <- xs, x D.== p:] +:+ (ss !: 1)

{-# NOINLINE quicksort #-}
quicksort:: PArray Double -> PArray Double 
quicksort xs = toPArrayP  (qsortVect' (fromPArrayP xs))
