{-# LANGUAGE ParallelArrays #-}
{-# OPTIONS_GHC -fvectorise #-}
 
module SP (skalar_omot)
where

import Data.Array.Parallel
import Data.Array.Parallel.Prelude
import Data.Array.Parallel.Prelude.Double as D
  
skalar_pro :: [:Double:] -> [:Double:] -> Double
skalar_pro xs ys = sumP [:x D.* y | x <- xs | y <- ys:]

-- drugi nacin koriscenjem funkcije zipWithP
-- skalar_pro xs ys = sumP (zipWithP (Data.Array.Parallel.Prelude.Double.*) xs ys)

{-# NOINLINE skalar_omot #-}
-- interfejs izmedju vektorizovanog i nevektorizovanog koda 
skalar_omot :: PArray Double -> PArray Double -> Double
skalar_omot v w = skalar_pro (fromPArrayP v) (fromPArrayP w)
